package cn.iocoder.yudao.module.member.service.order;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.order.vo.OrderDetailsReqVO;
import cn.iocoder.yudao.module.member.controller.admin.order.vo.OrderDetailsRespVO;
import cn.iocoder.yudao.module.member.controller.admin.order.vo.OrderMoneyRespVO;
import cn.iocoder.yudao.module.member.controller.admin.screen.vo.CarTeenInfoVO;
import cn.iocoder.yudao.module.member.controller.app.order.vo.AppOrderPageReqVO;
import cn.iocoder.yudao.module.member.controller.app.order.vo.AppOrderRespVO;
import cn.iocoder.yudao.module.member.controller.app.order.vo.AppOrderSaveReqVO;
import cn.iocoder.yudao.module.member.controller.app.order.vo.AppPageVo;
import cn.iocoder.yudao.module.member.dal.dataobject.order.DishOrderDO;

import javax.validation.Valid;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * 会员订单 Service 接口
 *
 * @author 开发账号
 */
public interface OrderService {

    /**
     * 创建会员订单
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createOrder(@Valid AppOrderSaveReqVO createReqVO);

    /**
     * 更新会员订单
     *
     * @param updateReqVO 更新信息
     */
    void updateOrder(@Valid AppOrderSaveReqVO updateReqVO);

    /**
     * 删除会员订单
     *
     * @param id 编号
     */
    void deleteOrder(Long id);

    /**
     * 获得会员订单
     *
     * @param id 编号
     * @return 会员订单
     */
    AppOrderRespVO getOrder(Long id);

    /**
     * 获得会员订单分页
     *
     * @param pageReqVO 分页查询
     * @return 会员订单分页
     */
    PageResult<DishOrderDO> getOrderPage(AppOrderPageReqVO pageReqVO);

    /**
     * 获得会员订单分页
     * @return
     */
    PageResult<AppOrderRespVO> getOrderList(AppPageVo vo);


    /**
     * 获取用户的未支付订单
     * @return
     */
    List<DishOrderDO> getToPay(List<Long> users);


    /**
     * 获取用户的未支付订单
     * @return
     */
    List<DishOrderDO> getToPayByOrder(List<Long> orderIds);

    /**
     * 更改用户的支付状态
     * @return
     */
    void updateBatch(List<DishOrderDO> orderDOS);

    /**
     * 根据时间获取用户的订单
     * @return
     */
    List<DishOrderDO> getDishOrderByTime(LocalDateTime startTime ,LocalDateTime endTime );

    PageResult<OrderDetailsRespVO> getPageOrderDetails(OrderDetailsReqVO reqVO);
    OrderDetailsRespVO getOrderDetailsAndUser(Long orderId);

    /**
     * 获取今日顾客总量
     * @return
     */
    Integer selectUser(Long storeId,String time);

    /**
     * 获取销售额
     * @return
     */
    BigDecimal getSaleMoney(Long storeId,String time);

    List<CarTeenInfoVO> getCarTeenInfo();

    /**
     * @Description: 根据会员编号，获得会员余额,充值金额,消费金额
     * @Author: qjq
     * @Date: 2024/4/24 上午9:52
     * @return
     */
    OrderMoneyRespVO getUserMeney(Long userId);


    Map<String,Object> getMoneyAndPeople(Long storeId);
}